@* The logarithm of a functional.
@c
/* Empty, waiting for |export| */
@ @(functional/log.h@>=
#ifndef __MATH_LOG_FUNCTIONAL__
#define __MATH_LOG_FUNCTIONAL__ 1.00
#include <math.h>
#include <math/functionalbase.h>
namespace math
{
    @[namespace functional@]
    {
	template<class T>@;
	class @[log : public base<T>@]
	{
	    @<Logarithm of a functional internal variables@>@;
	public:@;
	    @<Logarithm of a functional class methods@>@;
	};
    }
}
#endif
@ The functionals to be added are stored in a vector of pairs of weights and functionals.
@<Logarithm of a functional internal variables@>=
typedef base<T>* element_type;
element_type f;
@ 
@<Logarithm of a functional class methods@>=
log(element_type new_f) @[:@] f(new_f) @+{@+}
@ 
@<Logarithm of a functional class methods@>=
T eval(const matrix<T,unstructured,dense>& x)
{
    T result=::log(f->eval(x));
    if(!finite(result)) throw error::domain();
    return result;
}
@ The gradient of the logarithm is given by $\nabla f/f$.
@ @<Logarithm of a functional class methods@>=
matrix<T,unstructured,dense>& grad(const matrix<T,unstructured,dense>& x,
				   matrix<T,unstructured,dense>& dest)
{
    T result=f->eval(x);
    f->grad(x,dest);
    return dest/=result;
}
@ The Hessian is given by $\nabla^2 f/f - \nabla f\nabla^Tf/f^2$.
@<Logarithm of a functional internal variables@>=
matrix<T,symmetric,dense> Hdense;
matrix<T,symmetric,sparse> Hsparse;
matrix<T,unstructured,dense> aux;
@ @<Logarithm of a functional class methods@>=
matrix<T,symmetric,dense> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,dense>&
				dest)
{
    T result=f->eval(x);
    f->grad(x,aux);
    outerp(aux,&Hdense);
    Hdense/=(-result);
    f->hess(x,dest);
    dest+=Hdense;
    return dest/=result;
}
matrix<T,symmetric,sparse> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,sparse>&
				dest)
{
    T result=f->eval(x);
    f->grad(x,aux);
    outerp(aux,&Hsparse);
    Hdense/=(-result);
    f->hess(x,dest);
    dest+=Hsparse;
    return dest/=result;
}
