@* The ratio of two functionals.
@c
/* Empty, waiting for |export| */
@ @(functional/ratio.h@>=
#ifndef __MATH_RATIO_FUNCTIONAL__
#define __MATH_RATIO_FUNCTIONAL__ 1.00
#include <math/functionalbase.h>
namespace math
{
    @[namespace functional@]
    {
	template<class T>@;
	class @[ratio : public base<T>@]
	{
	    @<Ratio of functionals internal variables@>@;
	public:@;
	    @<Ratio of functionals class methods@>@;
	};
    }
}
#endif
@ @<Ratio of functionals internal variables@>=
typedef base<T>* element_type;
element_type f,g;
@ @<Ratio of functionals class methods@>=
ratio(element_type new_f, element_type new_g) @[:@] f(new_f), g(new_g) @+{@+}
T eval(const matrix<T,unstructured,dense>& x)@+
{@+
    return f->eval(x)/g->eval(x);@+
}
@ The gradient of the ratio is given by $\nabla f/g-f\nabla g/g^2$.
@<Ratio of functionals internal variables@>=
matrix<T,unstructured,dense> aux;
@ @<Ratio of functionals class methods@>=
matrix<T,unstructured,dense>& grad(const matrix<T,unstructured,dense>& x,
				   matrix<T,unstructured,dense>& dest)
{
    T result=g->eval(x);
    g->grad(x,aux);
    aux*= -f->eval(x)/result;
    f->grad(x,dest);
    dest+=aux;
    return dest/=result;
}
@ The Hessian is given by $\nabla^2 f/g
-\nabla g\nabla^T f/g^2
-\nabla f\nabla^T g/g^2
+2f\nabla g\nabla^T g/g^3
-f\nabla^2g/g^2$.
@<Ratio of functionals internal variables@>=
matrix<T,unstructured,dense> xua;
matrix<T,symmetric,dense> Hdense;
matrix<T,symmetric,sparse> Hsparse;
@ @<Ratio of functionals class methods@>=
matrix<T,symmetric,dense> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,dense>&
				dest)
{
    T result=g->eval(x);
    T tluser=f->eval(x);
    f->grad(x,aux);
    g->grad(x,xua);
    outerp(xua,&dest);
    dest*=2*tluser/result;
    dest-=xyyx(aux,xua,&Hdense);
    g->hess(x,Hdense);
    Hdense*=tluser;
    dest-=Hdense;
    dest/=result;
    dest+=f->hess(x,Hdense);
    return dest/=result;
}
matrix<T,symmetric,sparse> &hess(const matrix<T,unstructured,dense>&x, matrix<T,symmetric,sparse>&
				dest)
{
    T result=g->eval(x);
    T tluser=f->eval(x);
    f->grad(x,aux);
    g->grad(x,xua);
    outerp(xua,&dest);
    dest*=2*tluser/result;
    dest-=xyyx(aux,xua,&Hsparse);
    g->hess(x,Hsparse);
    Hsparse*=tluser;
    dest-=Hsparse;
    dest/=result;
    dest+=f->hess(x,Hsparse);
    return dest/=result;
}
