@** Computing a search direction. Once you have a line minimization algorithm the only thing that 
you still need in order to define a local minimization algorithm is a method for computing the
search direction.
@s searchdir int
@c
/* Empty, waiting for |export|. */
@ @(searchdirbase.h@>=
#ifndef __MATH_SEARCHDIRBASE__
#define __MATH_SEARCHDIRBASE__ 1.0
#include<math/math.h>
#include<math/functionalbase.h>
namespace math
{
    @[namespace @!searchdir@]
    {
	template<class T>@;
	class @[base@]
	{
	public:@;
	    virtual ~base(void)@+{@+}
	    @<Search direction base class methods@>@;
	};
    }
}
#endif
@ Now to the interface: The only thing a search direction method has to do is to compute a
descent direction based on a functional and a starting point. Our method will return the descent
direction.
@<Search direction base class methods@>=@!@:searchdir::base}{dir@>
virtual matrix<T,unstructured,dense>&
dir(functional::base<T> * f, const matrix<T,unstructured,dense>& xi,
	matrix<T,unstructured,dense>* dest)=0;
